// LAMIA 1999 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"
#include <string.h>

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _offset + _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
};

int main(int argc, char *argv[])
{

	char fname[11];
	int i,d;
	unsigned char id1[] = { 0x3f, 0xfd, 0xfe, 0x87, 0xf7 };
	unsigned char id2[] = { 0x10, 0x10, 0x10, 0x10, 0x10 };
	int dn = 0;

	struct fpos md[] =
	{
//		{ 0x3B, 0x01 },	// S~ Ȕԍ1
		{ 0x22, 0x0A },	// 01
		{ 0x1D, 0x09 },	// 02
		{ 0x09, 0x0B },	// 03
		{ 0x0E, 0x0B },	// 04
		{ 0x13, 0x02 },	// 05
		{ 0x13, 0x05 },	// 06
		{ 0x13, 0x0A },	// 07
		{ 0x31, 0x07 },	// 08
		{ 0x2C, 0x09 },	// 09
		{ 0x27, 0x09 },	// 10
		{ 0x36, 0x08 },	// 11
		{ 0x13, 0x0C },	// 12
		{ 0x18, 0x0B },	// 13
		{ 0x00, 0x00 },	// End of Data
	};

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>3)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	int numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x010);
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.ReadDATA1(0x4f, 0x27, 0x01, 0x10, 0x01, buff, 0x100);
		if ((!memcmp(&buff[0xfb],id1,sizeof(id1)-1) && dn==0) || dn==1 || dn==3)
		{
			printf("Disk A (or C) F܂.\n");
			fcut("PROG",  0x06, 0x03, 0x00, 0x01, 0x01, 0x0000, 0xb000);
			fcut("MUS00", 0x07, 0x03, 0x01, 0x0a, 0x01, 0x0000, 0x0800);
			if (dn) return 0;
		}
		else if ((!memcmp(&buff[0xfb],id2,sizeof(id2)-1) && dn==0) || dn==2)
		{
			printf("Disk B F܂.\n");
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i+1);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, 0x0800);
			}
			if (dn) return 0;
		}
	}
	return 0;
}

